;
;ハードウェア定義（みかん）
;
; 定義名がいまいち


VRAM40				equ	$4000
VRAM60				equ	$6000
VRAM00				equ	0
VRAM20				equ	$2000

VRAM80				equ	$8000
VRAM82				equ	$8200
VRAMA0				equ	$A000
VRAMA2				equ	$A200
VRAMC0				equ	$C000
VRAMC2				equ	$C200
VRAME0				equ	$E000
VRAME2				equ	$E200

IO_8251DATA			equ	$80			;8251C データ (I/O)
IO_8251STAT			equ	$81			;8251C ステータス、モード、コマンド (I/O)

;8255 は mode2
IO_8255A			equ	$90			;SUBCPUとの通信 (I/O)
IO_8255B			equ	$91			;プリンタ出力 (O) bitは反転して出力する
IO_8255C			equ	$92			;bit0:プリンタストローブ信号 bit1:CRTKILL bit2:CGROM bit3-7 SUBCPU との通信用 (I/O)
IO_8255MODE			equ	$93			;8255モード設定 (I/O)

IO_PSGREG			equ	$A0			;PSG レジスタラッチ (O)
IO_PSGWRITE			equ	$A1			;PSG 出力 (O)
IO_PSGREAD			equ	$A2			;PSG 入力 (I)

IO_FMREG			equ	$70			;FM音源カートリッジ
IO_FMWRITE			equ	$71			;
IO_FMREAD			equ	$73			;

IO_FMREGSR			equ	$A0			;FM音源(SR)
IO_FMWRITESR		equ	$A1			;
IO_FMREADSR			equ	$A3			;

IO_CMTVRAMTIMER		equ	$B0			;CMT VRAMアドレス タイマ割り込み設定 (O)

IO_FDD66SET			equ	$B1			;FDD66内蔵/外部 DMA設定
IO_CMTFDD66INT		equ	$B2			;bit0:FDD66割り込み 0:ON 1:OFF (I) bit1:CMT1出力 (O) bit3:CMT3出力 (O)
IO_DIRB2			equ	$B3			;bit0-3:0xB2の方向 0:入力 1:出力

IO_PRT232CSS		equ	$C0			;bit0-2:CSS (O) bit0:RS-232Cキャリア検出 (I) bit1:プリンタBusy (I)
IO_SCREENMODE		equ	$C1			;スクリーン解像度 モード設定 (O)
IO_KNJVOI			equ	$C2			;漢字・音声合成ROM制御
IO_KNJVOIRW			equ	$C3			;Port0xC2の入出力制御

IO_FDDREAD			equ	$D0			;FDDからのデータ入力 (I)
IO_FDDWRITE			equ	$D1			;FDDへのデータ出力 (O)
IO_FDDCNTREAD		equ	$D2			;FDDからの制御信号入力 bit0-3:入力(I) bit4-7:出力(O)
IO_FDDCNTWRITE		equ	$D3			;FDDへの制御信号出力 (O)

IO_FDD66BUF0		equ	$D0			;ディスク内部バッファ$000-$0FFのアクセスポート (I/O)
IO_FDD66BUF1		equ	$D1			;ディスク内部バッファ$100-$1FFのアクセスポート (I/O)
IO_FDD66BUF2		equ	$D2			;ディスク内部バッファ$200-$2FFのアクセスポート (I/O)
IO_FDD66BUF3		equ	$D3			;ディスク内部バッファ$300-$3FFのアクセスポート (I/O)
IO_FDD66STATM		equ	$D4			;モーター状態 bit1=Drv2 bit0=Drv1 1:停止中 0:動作中 (I)
IO_FDD66CTRLM		equ	$D6			;モーター制御 bit1=Drv2 bit0=Drv1 1:停止 　0:動作 (O)
IO_FDD66ADJUST		equ	$D8			;書き込み時の調整値(?)(O) 書き込み先trkが0-4の時1 それ以外0 (O)
IO_FDD66SECLEN		equ	$DA			;(15-転送セクタ数) ディスク内部バッファ及びuPD765の転送サイズ(O)
IO_FDD66STAT765		equ	$DC			;uPD765A ステータス (I)
IO_FDD66DATA765		equ	$DD			;uPD765A データレジスタ (I/O)
IO_FDD66VFO			equ	$DE			;読み書き時のVFO調整値(O)（エラー発生時に調整してリトライ）(O)

IO_VOICEFORMAT		equ	$E0			;音声合成LSI フォーマット (O)
IO_VOICEMODE		equ	$E1			;音声合成LSI モード (O)
IO_VOICEE2			equ	$E2			;設定禁止 (O)
IO_VOICECMD			equ	$E3			;コマンド書き込み (O)
IO_VOICESTAT		equ	$E4			;状態読み出し (I)

IO_BANKREAD0		equ	$F0			;メモリリード(0x0000-0x7FFF) bit0-3:0x0000-0x3FFF bit4-7:0x4000-0x7FFF (O)
IO_BANKREAD1		equ	$F1			;メモリリード(0x8000-0xFFFF) bit0-3:0x8000-0xBFFF bit4-7:0xC000-0xFFFF (O)
IO_BANKWRITE		equ	$F2			;メモリライト(0x0000-0xFFFF) bit0-1:0x0000-0x3FFF bit2-3:0x4000-0x7FFF (O)
									;                            bit4-5:0x8000-0xBFFF bit6-7:0xC000-0xFFFF
IO_MEMINTSET		equ	$F3			;メモリ/割り込み設定 (O)

IO_INT1VECTOR		equ	$F4			;INT1 SUB-CPU 割り込みベクタ (O)
IO_INT2VECTOR		equ	$F5			;INT2 JOYSTICK 7pin 割り込みベクタ (O)

IO_TIMERCOUNT		equ	$F6			;タイマ割り込みカウント設定 (O)
IO_TIMERVECTOR		equ	$F7			;タイマ割り込みベクタ (O)

IO_CGROMSET			equ	$F8			;CGROM設定 (O)

IO_KANJIADR			equ	$FC			;拡張漢字ROMアドレスラッチ (O)
IO_KANJIREADL		equ	$FD			;拡張漢字ROM左読み込み (I)
IO_KANJIREADR		equ	$FE			;拡張漢字ROM右読み込み (I)
IO_KANJIENABLE		equ	$FF			;拡張漢字ROM 0x00:ENABLE 0xFF:DISABLE (O)

;---------------------------------------------------------------------------------------------------
IO_SCCREG			equ	$78
IO_SCCWRITE			equ	$79
IO_SCCREAD			equ	$7A
IO_SCCMODE			equ	$7B
;---------------------------------------------------------------------------------------------------
; for Port 0x90-93
; (IO_8255A,IO_8255B,IO_8255C,IO_8255MODE)
; p6v の pio.cpp が詳しい

KEYF_SPACE			equ	%10000000
KEYF_SHIFT			equ	%00000001
KEYF_STOP			equ	%00000010
KEYF_UP				equ	%00000100
KEYF_DOWN			equ	%00001000
KEYF_LEFT			equ	%00100000
KEYF_RIGHT			equ	%00010000

KEYB_SPACE			equ	7
KEYB_SHIFT			equ	0
KEYB_STOP			equ	1
KEYB_UP				equ	2
KEYB_DOWN			equ	3
KEYB_LEFT			equ	5
KEYB_RIGHT			equ	4

;Port0x92
PRT_STROBE			equ	%00000001	;bit0
CRT_KILL			equ	%00000000	;bit1
CRT_ON				equ	%00000010	;bit1
CGROM_KILL			equ	%00000100	;bit2
CGROM_ON			equ	%00000000	;bit2

;bit3	INT(ReadOnly)	
;bit4	INTE2(Writable)	
;bit5	IBF(ReadOnly)	
;bit6	INTE1(Writeable)
;bit7	OBF(ReadOnly)	

;8049から読み出す時（8049から8255に値が出力された時）は、
;１）8049→8255にライトパルスを出力して、8255にデータを書き込む。
;２）8255は、データが書き込まれたら、IBFを L→H にする。
;３）Z80から、8255のデータを読み出す。完了したら、IBFを H→L にする。


;Port0x93
;xxxxnnnb = ビットnnn を b にする
;bit4 RIE	CPUに対するデータ読込み要求割り込みの許可フラグ 0=禁止 1=許可
;bit6 WIE	CPUに対するデータ書込み要求割り込みの許可フラグ	0=禁止 1=許可

;bit6,5: グループAのモード	1x:モード2 01:モード1 00:モード0
;bit4:   PortA				1:入力(読み) 0:出力(書き)
;bit3:   PortC(bit4-7)		1:入力(読み) 0:出力(書き)
;bit2:   グループBのモード	1:モード1 0:モード0
;bit1:   PortB				1:入力(読み) 0:出力(書き)
;bit0:   PortC(bit0-3)		1:入力(読み) 0:出力(書き)


;---------------------------------------------------------------------------------------------------
; for Port 0xA0-A2
; (IO_PSGREG,IO_PSGREAD,IO_PSGWRITE)
PADF_UP				equ	%00000001
PADF_DOWN			equ	%00000010
PADF_LEFT			equ %00000100
PADF_RIGHT			equ %00001000
PADF_A				equ	%00010000
PADF_B				equ	%00100000

PADB_UP				equ	0
PADB_DOWN			equ	1
PADB_LEFT			equ	2
PADB_RIGHT			equ 3
PADB_A				equ 4
PADB_B				equ 5
;---------------------------------------------------------------------------------------------------
; for Port 0xB0
; (IO_CMTVRAMTIMER)
CMT_ON				equ	%00001000	;CMT モーターオン
CMT_OFF				equ	0			;CMT モーターオフ
TIMER_OFF			equ	%00000001	;タイマ割り込みオフ
TIMER_ON			equ	0			;タイマ割り込みオン

PAGE00MODE5			equ	%00000100	;表示ページアドレス
PAGE40MODE5			equ	%00000110
PAGEC0MODE5			equ	%00000010
PAGE80MODE5			equ	%00000000

PAGE80				equ	%00000100
PAGEA0				equ	%00000110
PAGEC0				equ	%00000000
PAGEE0				equ	%00000010

;---------------------------------------------------------------------------------------------------
; for Port 0xB1
; (IO_FDD66SET)
FDD66EXTERNAL		equ	%00000100	;66用ディスクドライブ 外部接続
FDD66INTERNAL		equ	0			;66用ディスクドライブ 内蔵
FDD66DMAREAD		equ	%00000010	;DMA方向 READ
FDD66DMAWRITE		equ	0			;DMA方向 WRITE
FDD66DMAOFF			equ	%00000001	;DMA OFF
FDD66DMAON			equ	0			;DMA ON

;---------------------------------------------------------------------------------------------------
; for Port 0xC0
; (IO_PRT232CSS)
CSS1			equ	1
CSS2			equ	1<<1
CSS3			equ	1<<2

; for Port 0xC1
; (IO_SCREENMODE)
MODEF_RES320x200	equ	0			;解像度 320x200
MODEF_RES160x200	equ	%00001000	;解像度 160x200
MODEF_RES40x20		equ	0			;解像度 40x20
MODEF_RES32x16		equ	%00000010	;解像度 32x16
MODEF_GRAPHIC		equ	0			;グラフィックモード
MODEF_CHARACTER		equ	%00000100	;キャラクターモード

;---------------------------------------------------------------------------------------------------
; for Port 0xF0,0xF1
; (IO_BANKREAD0/1)
;
BANK_READNONE		equ	%0000		;割り当てなし
BANK_READBASIC		equ	%0001		;BASIC ROM
BANK_READVOICEKANJI	equ	%0010		;VOICE+KANJI
BANK_READSLOT0		equ	%0011		;SLOT ROM(0)
BANK_READSLOT1		equ	%0100		;SLOT ROM(1)
BANK_READBASVK		equ	%0101		;[H] BASIC ROM / [L] VOICE+KANJI
BANK_READVKBAS		equ	%0110		;[H] VOICE+KANJI / [L] BASIC ROM
BANK_READSLOT01		equ	%0111		;[H] SLOT ROM(0) / [L] SLOT ROM(1)
BANK_READSLOT10		equ	%1000		;[H] SLOT ROM(1) / [L] SLOT ROM(0)
BANK_READBASSLOT0	equ	%1001		;[H] BASIC ROM / [L] SLOT ROM(0)
BANK_READSLOT0BAS	equ	%1010		;[H] SLOT ROM(0) / [L] BASIC ROM
BANK_READVKSLOT1	equ	%1011		;[H] VOICE+KANJI / [L] SLOT ROM(1)
BANK_READSLOT1VK	equ	%1100		;[H] SLOT ROM(1) / [L] VOICE+KANJI
BANK_READINTRAM		equ	%1101		;Internal RAM
BANK_READEXTRAM		equ	%1110		;External RAM
;BANK_READNONE		equ	%1111		;割り当てなし

; for Port 0xF2
; (IO_BANKWRITE)
BANK_WRITENONE		equ	%00			;割り当てなし
BANK_WRITEINTRAM	equ	%01			;Internal RAM
BANK_WRITEEXTRAM	equ	%10			;External RAM
BANK_WRITEBOTHRAM	equ	%11			;Internal RAM / External RAM

; for Port 0xF3
; (IO_MEMINTSET)

MEMF_M1WAIT			equ	%10000000	;M1サイクルでのウェイト 0:OFF 1:ON
MEMF_ROMWAIT		equ	%01000000	;ROMウェイト 0:OFF 1:ON
MEMF_RAMWAIT		equ	%00100000	;RAMウェイト 0:OFF 1:ON
INTF_INT2OUT		equ	%00010000	;INT2 JOYSTICK 7pin 割り込み時ベクタ 0:出力しない 1:出力する
INTF_INT1OUT		equ	%00001000	;INT1 SUB-CPU 割り込み時ベクタ 0:出力しない 1:出力する
INTF_ENABLETIMER	equ	%00000100	;タイマ割り込み 0:ENABLE 1:DISABLE
INTF_ENABLEINT2		equ	%00000010	;INT2 JOYSTICK 7pin 割り込み 0:ENABLE 1:DISABLE
INTF_ENABLEINT1		equ	%00000001	;INT1 SUB-CPU 割り込み 0:ENABLE 1:DISABLE

; for Port 0xF8
; (IO_CGROMSET)
MEMF_CGROMWAIT		equ	%10000000	;CGROMでのウェイト
MEMF_CGROMENABLE	equ	%01000000	;CGROMのリード 0:DISABLE 1:ENABLE
;MEMF_CGROMMASK		equ	%00111000	;CGROM bit2-0 マスク
;MEMF_CGROMREAD		equ	%00000111	;アドレスA15-13 がbit2-0 に一致時、CGROM にアクセスする。



